summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--debian/tests/control4
-rwxr-xr-xtests/tests/tagupl60
2 files changed, 64 insertions, 0 deletions
diff --git a/debian/tests/control b/debian/tests/control
index 2b495ac..b3e1b32 100644
--- a/debian/tests/control
+++ b/debian/tests/control
@@ -64,6 +64,10 @@ Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime
Restrictions: x-dgit-git-only
+Tests: tagupl
+Tests-Directory: tests/tests
+Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, libdpkg-perl, libgit-wrapper-perl, liblist-compare-perl, libstring-shellquote-perl, libtry-tiny-perl
+
Tests: test-list-uptodate
Tests-Directory: tests/tests
Depends: git
diff --git a/tests/tests/tagupl b/tests/tests/tagupl
new file mode 100755
index 0000000..8e0fc8d
--- /dev/null
+++ b/tests/tests/tagupl
@@ -0,0 +1,60 @@
+#!/bin/bash
+set -e
+. tests/lib
+
+t-dependencies DEBORIG
+
+t-debpolicy
+
+t-archive-none example
+t-git-none
+t-worktree 1.0
+
+v=1.0-1
+
+cd $p
+git checkout --orphan upstream quilt-tip-2
+git rm -rf debian
+git commit -m 'pseudo-upstream'
+git tag upstream/1.0
+
+git checkout -B master quilt-tip-2
+
+#git-deborig
+#t-dgit --quilt=gbp --dgit-view-save=split.b1 push-source --new --overwrite
+#xxx
+
+upstream=$(git rev-parse upstream/1.0~0)
+
+tagmessage="example release 1.0-1 for unstable
+
+wibble wibble
+
+[dgit distro=test-dummy split --quilt=gbp]
+[dgit please-upload upstream-tag=upstream/1.0 upstream=$upstream]"
+
+tagname=test-dummy/$v
+
+git tag -u Senatus -s -m "$tagmessage" $tagname
+
+cd ..
+mkdir tagupl
+cd tagupl
+
+export DGIT_DRS_EMAIL_NOREPLY=noreply@example.org
+export DGIT_DRS_SENDMAIL=$troot/tstunt/sendmail
+export DGIT_DRS_DGIT=$troot/tstunt/dgit
+t-chain-test-somehow
+
+DGIT_DRS_ANY_URL=1 \
+DGIT_DRS_MODE="tag2upload $tmp/$p $tagname" \
+ $troot/drs-git-ext
+
+# todo: test each miss/rejection
+
+cd $tmp/$p
+
+t-dgit fetch
+t-pushed-good master
+
+t-ok